unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, interpreter, checklst;

type
  TForm1 = class(TForm)
    Interpreter1: TInterpreter;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Memo1: TMemo;
    Memo2: TMemo;
    GroupBox3: TGroupBox;
    CheckBox1: TCheckBox;
    Button1: TButton;
    CheckListBox1: TCheckListBox;
    procedure Interpreter1Refresh(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Interpreter1Token(Sender: TObject; Code, Params: String;
      var Handled: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    { Declare some functions for the text parser; these are called
      whenever the parser finds the associated string }
    { First function does nothing than beeping and deletes the tag }
    function OnBeepToken(Params: string): string;
    { This one replaces the tag with current date, and adds the current time
      if the parameter +time was committed }
    function OnDateToken(Params: string): string;
    { The last example display the given parameter as an alert box}
    function OnMessageToken(Params: string): string;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{OnRefresh is called every time the parser changes it's output}
procedure TForm1.Interpreter1Refresh(Sender: TObject);
begin
   Memo2.Lines:= Interpreter1.Output;
end;

procedure TForm1.FormShow(Sender: TObject);
var
   i: Integer;
begin
   Memo1.Lines.Clear;
   with CheckListBox1 do begin
      Items:= Interpreter1.Token;
      for i:= 0 to Items.Count -1 do begin
         Checked[i]:= true;
      end;
   end;
   CheckBox1.Checked:= Interpreter1.Automatic;
   { This one clears Memo2; we could have done it manually also } 
   Interpreter1.Refresh;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
   Interpreter1.Input:= TInOutStrings(Memo1.Lines);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Interpreter1.AddToken('beep', OnBeepToken);
   Interpreter1.AddToken('message', OnMessageToken);
   Interpreter1.AddToken('date', OnDateToken);
end;

function TForm1.OnBeepToken(Params: string): string;
begin
   Beep;
   Result:= '';
end;

function TForm1.OnMessageToken(Params: string): string;
begin
  MessageDlg('Message:' + chr(13) + Params,mtInformation,[mbOK],0);
  Result:= '';
end;

function TForm1.OnDateToken(Params: string): string;
begin
   if Pos('+time', AnsiLowerCase(Params))>0 then
      Result:= DateToStr(Now) + ' '  + TimeToStr(Now)
   else
      Result:= DateToStr(Now);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
   Interpreter1.Automatic:= Checkbox1.Checked;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   Interpreter1.Refresh;
end;

procedure TForm1.Interpreter1Token(Sender: TObject; Code, Params: String;
  var Handled: Boolean);
var
   Index: Integer;
begin
   { Despite of the ability to add persistent tags, we can provide
     further tags with the OnToken Event. It is called before the
     Interpreter tries to find that tag in its token list.
     You can also prevent a token from being executed by setting
     Handled to true.}
   Index:= CheckListBox1.Items.IndexOf(Code);
   if Index>-1 then Handled:= not(ChecklistBox1.Checked[Index]);
end;

end.
