unit InterpreterProperty;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, DsgnIntf, InterpreterEditor;

type
   TInterpreterProperty=class(TPropertyEditor)
     private
     public
       function GetValue: string; override;
       procedure Edit; override;
       procedure OnOutRefresh(Sender: TObject);
       procedure OnInRefresh(Sender: TObject);
   end;

implementation

uses Interpreter;

function TInterpreterProperty.GetValue: string;
begin
   Result:= '(TInOutStrings)';
end;

procedure TInterpreterProperty.Edit;
var
   i: Integer;
   tmpInterpreter: TInterpreter;
   tmpEvent: TNotifyEvent;
begin
   InterpreterEditorForm:= TInterpreterEditorForm.Create(Application);
   InterpreterEditorForm.InMemo.OnChange:= OnInRefresh;
   tmpInterpreter:= GetComponent(0) as TInterpreter;
   tmpEvent:= tmpInterpreter.OnRefresh;
   tmpInterpreter.OnRefresh:= OnOutRefresh;
   InterpreterEditorForm.InMemo.Lines:= tmpInterpreter.Input;
   if InterpreterEditorForm.ShowModal=mrOK then begin
      for i:= 0 to PropCount-1 do begin
         tmpInterpreter:= GetComponent(i) as TInterpreter;
         tmpInterpreter.Input:= TInOutStrings(InterpreterEditorForm.InMemo.Lines);
      end;
   end;
   tmpInterpreter.OnRefresh:= tmpEvent;
   InterpreterEditorForm.Free;
   InterpreterEditorForm:= nil;
end;

procedure TInterpreterProperty.OnOutRefresh(Sender: TObject);
begin
  if InterpreterEditorForm<>nil then
      InterpreterEditorForm.OutMemo.Lines:= (Sender as TInterpreter).Output;
end;

procedure TInterpreterProperty.OnInRefresh(Sender: TObject);
begin
   (GetComponent(0) as TInterpreter).Input:= TInOutStrings(InterpreterEditorForm.InMemo.Lines);
end;

end.
